"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Write a string to a buffer.
 */
exports.writeString = function (buffer, value, offset) {
    if (offset === void 0) { offset = 0; }
    var len = Buffer.byteLength(value);
    buffer.writeUInt16BE(len, offset);
    offset += 2;
    offset += buffer.write(value, offset, "utf8");
    return offset;
};
/**
 * Read a string from a buffer.
 */
exports.readString = function (buffer, offset) {
    var len = buffer.readUInt16BE(offset);
    offset += 2;
    var value = buffer.slice(offset, offset + len).toString("utf8");
    offset += len;
    return {
        offset: offset,
        value: value,
    };
};
//# sourceMappingURL=buffer.js.map