/// <reference types="node" />
export interface Footer {
    readonly headerLength: number;
    readonly headerOffset: number;
    readonly contentLength: number;
    readonly contentOffset: number;
}
/**
 * Reads a footer from a file descriptor with the size of the file
 */
export declare const readFooter: (fd: number, size: number) => Footer;
/**
 * Creates a footer defining byte lengths and offsets
 */
export declare const createFooter: (headerLength: number, headerOffset: number, contentLength: number, contentOffset: number) => Buffer;
