"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var os = require("os");
var path = require("path");
exports.mkdirp = function (p) {
    try {
        fs.mkdirSync(p);
    }
    catch (error) {
        if (error.code !== "EEXIST") {
            var parent_1 = path.dirname(p);
            if (parent_1 === p) {
                throw error;
            }
            exports.mkdirp(parent_1);
            fs.mkdirSync(p);
        }
    }
};
exports.getXdgCacheHome = function (name) {
    switch (process.platform) {
        case "win32":
            return path.join(process.env.XDG_CACHE_HOME || path.join(os.homedir(), "AppData/Local"), name + "/Cache");
        case "darwin":
            return path.join(process.env.XDG_CACHE_HOME || path.join(os.homedir(), "Library/Caches"), name);
        default:
            return path.join(process.env.XDG_CACHE_HOME || path.join(os.homedir(), ".cache"), name);
    }
};
//# sourceMappingURL=util.js.map